VAR

  long var_base
  
OBJ

  dummy : "dummy"

PUB new(base, index) | obj_base, i

  ''Create a callback object from the caller's base address and procedure index.
  ''It is called thus:
  ''
  ''  cbo := callback.new(@@0, i), where i is the procedure number.
  ''
  ''Procedures are numbered, starting at 1 for the first public procedure, incrementing
  ''by one in order of appearance. Once the public procedures are counted, enumeration continues
  ''at the first private procedure, again incrementing by one in order of appearance.
  ''i must range from 0 to 63. If it's outside this range, zero is returned.

  if index => 0 and index < 64
    obj_base := base + byte[base + 2] << 2
    repeat i from 0 to byte[base + 3] - 1
      if @@0 - base == word[obj_base + i << 2]
        return ((@@0 - base) & $7ffc) << 17 | ((@var_base - word[obj_base + i << 2 + 2]) & $7ffc) << 4 | index
  return 0      

PUB do0(self)

  ''Call a callback routine indicated by the callback object, self. The routine called should take
  ''no arguments.

  if self
    word[@@$18] := -(self >> 17 & $7ffc)            'Put the callback's object offset into word 0 of the object vector.
    word[@@$1a] := (self >>  4 & $7ffc) - @var_base 'Put the callback's VAR offset into word 1 of the object vector.
    byte[@@$a0] := self & $3f                       'Put the index number of the callback in the call to dummy._0.
    return dummy._0                                 'Call the callback routine, and return its return value, if any.
     
PUB do1(self, a)

  ''Call a callback routine indicated by the callback object, self. The routine called should take
  ''one argument.

  if self
    word[@@$18] := -(self >> 17 & $7ffc) 
    word[@@$1a] := (self >>  4 & $7ffc) - @var_base 
    byte[@@$d0] := self & $3f            
    return dummy._1(a)               
     
PUB do2(self, a, b)

  ''Call a callback routine indicated by the callback object, self. The routine called should take
  ''two arguments.

  if self
    word[@@$18] := -(self >> 17 & $7ffc) 
    word[@@$1a] := (self >>  4 & $7ffc) - @var_base 
    byte[@@$102] := self & $3f            
    return dummy._2(a, b)
     
PUB do3(self, a, b, c)

  ''Call a callback routine indicated by the callback object, self. The routine called should take
  ''three arguments.

  if self
    word[@@$18] := -(self >> 17 & $7ffc) 
    word[@@$1a] := (self >>  4 & $7ffc) - @var_base 
    byte[@@$135] := self & $3f            
    return dummy._3(a, b, c)